package org.jboss.seam.example.entityconverter;

import java.util.List;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

/**
 * @author pmuir
 *
 */

@Entity
public class Client {
	
	@Id @GeneratedValue
	private Integer id;

	private String name;
	
	private String address;
	
	private String telephoneNumber;
	
	private String faxNumber;
	
	@ManyToOne
	private ClientType clientType = new ClientType();
	
	@OneToMany
	private List<Factory> factories;
	
	
	public Client() {
	}

	public String getAddress() {
		return address;
	}
    
    public ClientType getClientType() {
		return clientType;
	}
    
    

	public String getFaxNumber() {
		return faxNumber;
	}

	public Integer getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public String getTelephoneNumber() {
		return telephoneNumber;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public void setClientType(ClientType clientType) {
		this.clientType = clientType;
	}

	public void setFaxNumber(String faxNumber) {
		this.faxNumber = faxNumber;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setTelephoneNumber(String telephoneNumber) {
		this.telephoneNumber = telephoneNumber;
	}

	@Override
    public String toString() {
    	return name + "(" + id + ")";
    }

	public List<Factory> getFactories() {
		return factories;
	}

	public void setFactories(List<Factory> factories) {
		this.factories = factories;
	}
}
