package org.jboss.seam.entityconverter;

import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.webapp.ConverterTag;
import javax.faces.webapp.UIComponentTag;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;


public class ConvertEntityTag extends ConverterTag {

	private static final long serialVersionUID = 3728517107430100429L;

	private static final String CONVERTER_ID = "org.jboss.seam.EntityConverter";

	private String entityClass;

	public String getEntityClass() {
		return entityClass;
	}

	public void setEntityClass(String entityClass) {
		this.entityClass = entityClass;
	}

	@Override
	public void setPageContext(PageContext arg0) {
		super.setPageContext(arg0);
		setConverterId(CONVERTER_ID);
	}

	@Override
	protected Converter createConverter() throws JspException {
		EntityConverter converter = (EntityConverter) super.createConverter();
		FacesContext facesContext = FacesContext.getCurrentInstance();
		setConverterEntityClass(facesContext, converter, entityClass);
		return converter;
	}

	private static void setConverterEntityClass(FacesContext facesContext,
			EntityConverter converter, String value) {
		if (value == null)
			return;
		if (UIComponentTag.isValueReference(value)) {
			ValueBinding vb = facesContext.getApplication().createValueBinding(
					value);
			converter.setEntityClass((String) vb.getValue(facesContext));
		} else {
			converter.setEntityClass(value);
		}
	}

}
