package org.jboss.seam.entityconverter;

import static org.jboss.seam.annotations.Install.BUILT_IN;

import java.io.Serializable;

import org.jboss.seam.Component;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Install;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Transactional;
import org.jboss.seam.contexts.Contexts;

import javax.persistence.EntityManager;

@Name("org.jboss.seam.entityconverter.lookup")
@Install(precedence=BUILT_IN)
@Scope(ScopeType.CONVERSATION)
public class Lookup implements Serializable {

	private EntityManager entityManager;

	public static Lookup instance() {
		if (!Contexts.isEventContextActive()) {
			throw new IllegalStateException("No active event scope");
		}
		return (Lookup) Component.getInstance(
				Lookup.class, ScopeType.EVENT, true);
	}

	@SuppressWarnings("unchecked")
	@Transactional
	public Object find(Class clazz, Object id) {
		getEntityManager().joinTransaction();
		return getEntityManager().find(clazz, id);
	}

	public EntityManager getEntityManager() {
		if (entityManager == null) {
			entityManager = (EntityManager) Component
					.getInstance("entityManager");
		}
		return entityManager;
	}

	public void setEntityManager(EntityManager entityManager) {
		this.entityManager = entityManager;
	}
}
